		.title	dmapurge - fddio


* Include File -------------------------------- *

		.include	macro.mac
		.include	iomap.mac
		.include	iocscall.mac
		.include	iocswork.mac

		.include	dmapurge.mac


* Macro --------------------------------------- *

FDD_MOTOR_ON:	.macro
		.ifdef	HAVE_FDD_MOTOR_ON
		bsr	fdd_motor_on
		.else
		jsr	($ff8ed6)
		.endif
		.endm

GET_FD_PARAM:	.macro
		.ifdef	HAVE_GET_FD_PARAM
		bsr	get_fd_param
		.else
		jsr	($ff8dc0)
		.endif
		.endm

FD_SEEK:	.macro
		.ifdef	HAVE_FD_SEEK
		bsr	fd_seek
		.else
		jsr	($ff8e04)
		.endif
		.endm

MAKE_FDC_CMD:	.macro
		.ifdef	HAVE_MAKE_FDC_CMD
		bsr	make_fdc_cmd
		.else
		jsr	($ff8e20)
		.endif
		.endm

* IOCS [N FDCMD  9 oCg
WRITE_FDC_CMD9:	.macro
		.ifdef	HAVE_WRITE_FDC_CMD9
		bsr	write_fdc_cmd9
		.else
		jsr	($ff8e9c)
		.endif
		.endm

* a0.l  d0.w oCg
WRITE_FDC_CMD:	.macro
		.ifdef	HAVE_WRITE_FDC_CMD9
		bsr	write_fdc_cmd
		.else
		jsr	($ff8ea2)
		.endif
		.endm

FDD_RETRY:	.macro
		.ifdef	HAVE_FDD_RETRY
		bsr	fdd_retry
		.else
		jsr	($ff8a26)
		.endif
		.endm

FDD_MOTOR_OFF:	.macro
		.ifdef	HAVE_FDD_MOTOR_OFF
		bsr	fdd_motor_off
		.else
		jsr	($ff8f54)
		.endif
		.endm

FD_REPEAT:	.macro
		.ifdef	HAVE_FD_REPEAT
		bra	fd_repeat
		.else
		jmp	($ff8d68)
		.endif
		.endm

SENSE_INT_STAT:	.macro
		.ifdef	HAVE_SENSE_INT_STAT
		bsr	sense_int_stat
		.else
		jsr	($ff1b62)
		.endif
		.endm

INS_EJE_CHECK:	.macro
		.ifdef	HAVE_INS_EJE_CHECK
		bsr	ins_eje_check
		.else
		move.l	a4,-(sp)
		jsr	($ff1c36)
		movea.l	(sp)+,a4
		.endif
		.endm

WAIT_5NS:	.macro
		.ifdef	HAVE_WAIT_5NS
		bsr	wait_5ns
		.else
		jsr	($ff0d12)
		.endif
		.endm

WAIT_BUSY_OFF:	.macro	ea
		.local	loop
loop:
.if 0
		moveq	#$1f,d0
		and.b	ea,d0
.else
		btst	#5,ea
.endif
		bne	loop
		.endm


* Constant ------------------------------------ *

* FDC̃R}h
FDC_READ_DIAGNOSTIC:		.equ	2
FDC_SPECIFY:			.equ	3
FDC_SENSE_DEVICE_STATUS:	.equ	4
FDC_WRITE_DATA:			.equ	5
FDC_READ_DATA:			.equ	6
FDC_RECALIBRATE:		.equ	7
FDC_SENSE_INTERRUPT_STATUS:	.equ	8
FDC_WRITE_DELETED_DATA:		.equ	9
FDC_READ_ID:			.equ	10
FDC_READ_DELETED_DATA:		.equ	12
FDC_WRITE_ID:			.equ	13
FDC_SEEK:			.equ	15
FDC_SCAN_EQUAL:			.equ	17

		.ifndef	FDC_MT
FDC_MT:		.equ	1<<7
FDC_MF:		.equ	1<<6
		.endif


* Text Section -------------------------------- *

		.cpu	68020

		.text


* xN^e[u ------------------------------ *

		.quad
fddio_hook_table::
		IOCSV	_B_VERIFY,	iocs_b_verify
		IOCSV	_B_READDI,	iocs_b_readdi
		IOCSV	_B_DSKINI,	iocs_b_dskini
		IOCSV	_B_WRITE,	iocs_b_write
		IOCSV	_B_READ,	iocs_b_read
		IOCSV	_B_FORMAT,	iocs_b_format
		IOCSV	_B_WRITED,	iocs_b_writed
		IOCSV	_B_READDL,	iocs_b_readdl
		V_END


* IOCS _B_VERIFY ------------------------------ *
* in	d1.hb	PDA
*	d1.b	[h
*	d2.l	ړIʒu
*	d3.l	oCg
*	a1.l	obt@AhX
* out	d0.l	FDC Xe[^X
* break	d2-d3/a1

b_verify_sasi:
		jmp	([orig_iocs_b_verify,pc])

iocs_b_verify::
		btst	#4+8,d1
		beq	b_verify_sasi		;SASI

		FDD_MOTOR_ON
		PUSH	d1/d4-d7/a2
		GET_FD_PARAM			;ZN^Ƃ̒萔l		
		tst.l	d0
		bne	b_verify_error

		FD_SEEK
		btst	#ST0_NR+24,d0
		bne	b_verify_error

		and.b	#FDC_MT+FDC_MF,d1
		ori.b	#FDC_SCAN_EQUAL,d1
b_verify_loop:
		MAKE_FDC_CMD			;FDCւ̃R}hobt@ɓWJ
		rol.l	#8,d2
		addq.l	#2,a0
		move.l	d2,(a0)+		;ZN^ID
		ror.l	#8,d2
		move.b	d2,(a0)+		;ŏIZN^ԍ͊JnƓ
		move.b	d7,(a0)+		;Gap3 ǂݔ΂oCg
		move.b	d6,(a0)			;Data 

* f[^
		MASK_INT
		WRITE_FDC_CMD9			;FDCɃR}h

		movem.l	d4-d5/a1-a3,-(sp)
		lea	(FDC_STAT),a2
		lea	(FDC_DATA-FDC_STAT,a2),a3
		moveq	#$b0,d4
@@:
		moveq	#$f0,d0
		and.b	(a2),d0
		cmp.b	d4,d0			;$b* ɂȂ܂ő҂
		bne	@b
		move.b	(a1)+,(a3)		;1 oCg
		subq	#1,d5
		bne	@b

		WAIT_BUSY_OFF (a2)		;슮҂
		movem.l	(sp)+,d4-d5/a1-a3
		UMASK_INT
		SENSE_INT_STAT			;Xe[^Xǂݍ

		bsr	get_result_stat		;UgXe[^X𓾂
		btst	#ST2_SN+8,d0
		bne	b_verify_error		;SCAN R}hōŏIZN^܂
		btst	#ST0_IC0+24,d0		;𖞑Ȃ
		beq	b_verify_end
		btst	#ST0_NR+24,d0
		bne	b_verify_error		;Not Ready

		FDD_RETRY
		dbra	d4,b_verify_loop
b_verify_error:
		POP	d1/d4-d7/a2
		FDD_MOTOR_OFF
		rts

b_verify_end:
		lea	(b_verify_table,pc),a2
		FD_REPEAT			;JԂ
b_verify_table:
		.dc	b_verify_error-b_verify_table
		.dc	b_verify_loop-b_verify_table
		.dc	b_verify_loop-b_verify_table


* IOCS _B_READDI ------------------------------ *
* in	d1.hb	PDA
*	d1.b	[h
*	d2.l	ړIǂݍ݈ʒu
*	d3.l	oCg
*	a1.l	obt@AhX
* out	d0.l	FDC Xe[^X
* break	d2-d3/a1

b_readdi_sasi:
		jmp	([orig_iocs_b_readdi,pc])

iocs_b_readdi:
		btst	#4+8,d1
		beq	b_readdi_sasi		;SASI

		FDD_MOTOR_ON
		PUSH	d1/d4-d7/a2
		GET_FD_PARAM			;ZN^Ƃ̒萔l		
		tst.l	d0
		bne	b_readdi_error

		FD_SEEK
		btst	#ST0_NR+24,d0
		bne	b_readdi_error

		and.b	#FDC_MF,d1
		ori.b	#FDC_READ_DIAGNOSTIC,d1
b_readdi_loop:
		MAKE_FDC_CMD			;FDCւ̃R}hobt@ɓWJ
		rol.l	#8,d2
		addq.l	#2,a0
		move.l	d2,(a0)+		;ZN^ID
		ror.l	#8,d2
		move.b	d2,(a0)+		;ŏIZN^ԍ͊JnƓ
		move.b	d7,(a0)+		;Gap3 ǂݔ΂oCg
		move.b	d6,(a0)			;Data 

* f[^ǂݍ
		MASK_INT
		WRITE_FDC_CMD9			;FDCɃR}h

		movem.l	d4-d5/a1-a3,-(sp)
		lea	(FDC_STAT),a2
		lea	(FDC_DATA-FDC_STAT,a2),a3
		moveq	#$f0,d4
@@:
		cmp.b	(a2),d4			;$f* ɂȂ܂ő҂
		bhi	@b
		move.b	(a3),(a1)+		;1 oCgǂݍ
		subq	#1,d5
		bne	@b

		WAIT_BUSY_OFF (a2)		;슮҂
		movem.l	(sp)+,d4-d5/a1-a3
		UMASK_INT
		SENSE_INT_STAT			;Xe[^Xǂݍ

		bsr	get_result_stat		;UgXe[^X𓾂
		move.l	#1<<(ST1_ND+16)+1<<(6+16)+1<<(7+8)+1<<(ST2_CM+8),d1
		and.l	d0,d1
		bne	b_readdi_end
		btst	#ST0_IC0+24,d0
		beq	b_readdi_end
		btst	#ST0_NR+24,d0
		bne	b_readdi_error		;Not Ready

		FDD_RETRY
		dbra	d4,b_readdi_loop
b_readdi_error:
		POP	d1/d4-d7/a2
		FDD_MOTOR_OFF
		rts

b_readdi_end:
		lea	(b_readdi_table,pc),a2
		FD_REPEAT			;JԂ
b_readdi_table:
		.dc	b_readdi_error-b_readdi_table
		.dc	b_readdi_loop-b_readdi_table
		.dc	b_readdi_loop-b_readdi_table


* IOCS _B_DSKINI ------------------------------ *
* in	d1.hb	PDA
*	d2.l	[^It܂ł̎
*	a1.l	SPECIFY R}h̃AhX
* break	d0/a0
* l:
*	SPECIFY R}h ND rbg͕K 1 ɂȂ
*	ȂȂ.

b_dskini_sasi:
		jmp	([orig_iocs_b_dskini,pc])

iocs_b_dskini:
		btst	#4+8,d1
		beq	b_dskini_sasi		;SASI

		lea	(FDTINIT),a0
		move	d2,d0
		bne	@f
		move	#200,d0			;0w莞2b
@@:
		move	d0,(a0)+		;[^off܂ł̎Ԃݒ
		move	d0,(a0)+		;

		INS_EJE_CHECK			;FDDԌ

		move.b	(FDC_STAT),d0
		btst	#4,d0
		beq	@f			;E-PHASE󂯎v͂Ȃ
		SENSE_INT_STAT			;FDCXe[^X󂯎
@@:
		movea.l	a1,a0
		tst.l	a0
		bne	@f
		lea	(dskini_default,pc),a0	;Wݒɖ߂
@@:
		move.b	(2,a0),-(sp)
		ori.b	#1,(sp)			;ND=1:CPU ][hɂ
		move	(a0),-(sp)
		lea	(sp),a0
		moveq	#3-1,d0
		WRITE_FDC_CMD			;FDCɃR}h
		addq.l	#4,sp
		FDD_MOTOR_OFF
		rts

dskini_default:
		.dc.b	FDC_SPECIFY,$d0,($10.or.1)
		.even


* IOCS _B_WRITE ------------------------------- *
* in	d1.hb	PDA
*	d1.b	[h
*	d2.l	ړI݈ʒu
*	d3.l	oCg
*	a1.l	f[^AhX
* out	d0.l	FDC Xe[^X
* break	d2-d3/a1
* l:
*	_B_WRITED ƃR[hpĂ.

b_write_sasi:
		jmp	([orig_iocs_b_write,pc])

iocs_b_write:
		btst	#4+8,d1
		beq	b_write_sasi		;SASI

		FDD_MOTOR_ON
		PUSH	d1/d4-d7/a2
		GET_FD_PARAM			;ZN^Ƃ̒萔l		
		tst.l	d0
		bne	b_write_error

		FD_SEEK
		btst	#ST0_NR+24,d0
		bne	b_write_error

		and.b	#FDC_MT+FDC_MF,d1
		ori.b	#FDC_WRITE_DATA,d1
		bra	b_write_loop
b_write_loop_t:
		moveq	#12,d0			;gbNړꍇ
		WAIT_5NS			;0.6msҋ@
b_write_loop:
		MAKE_FDC_CMD			;FDCւ̃R}hobt@ɓWJ
		rol.l	#8,d2
		addq.l	#2,a0
		move.l	d2,(a0)+		;ZN^ID
		ror.l	#8,d2
		move.b	d2,(a0)+		;ŏIZN^ԍ͊JnƓ
		move.b	d7,(a0)+		;Gap3 ǂݔ΂oCg
		move.b	d6,(a0)			;Data 

* f[^
		MASK_INT
		WRITE_FDC_CMD9			;FDCɃR}h

		movem.l	d4-d5/a1-a3,-(sp)
		lea	(FDC_STAT),a2
		lea	(FDC_DATA-FDC_STAT,a2),a3
		moveq	#$b0,d4
@@:
		moveq	#$f0,d0
		and.b	(a2),d0
		cmp.b	d4,d0			;$b* ɂȂ܂ő҂
		bne	@b
		move.b	(a1)+,(a3)		;1 oCg
		subq	#1,d5
		bne	@b

		WAIT_BUSY_OFF (a2)		;슮҂
		movem.l	(sp)+,d4-d5/a1-a3
		UMASK_INT
		SENSE_INT_STAT			;Xe[^Xǂݍ

		bsr	get_result_stat		;UgXe[^X𓾂
		btst	#ST0_IC0+24,d0
		beq	b_write_end
		btst	#ST0_NR+24,d0
		bne	b_write_error		;Not Ready
		btst	#ST1_NW+16,d0
		bne	b_write_error		;Not Writable(Write Protect)

		FDD_RETRY
		dbra	d4,b_write_loop
b_write_error:
		POP	d1/d4-d7/a2
		FDD_MOTOR_OFF
		rts

b_write_end:
		lea	(b_write_table,pc),a2
		FD_REPEAT			;JԂ
b_write_table:
		.dc	b_write_error-b_write_table
		.dc	b_write_loop-b_write_table
		.dc	b_write_loop_t-b_write_table


* IOCS _B_READ -------------------------------- *
* in	d1.hb	PDA
*	d1.b	[h
*	d2.l	ړIǂݍ݈ʒu
*	d3.l	oCg
*	a1.l	obt@AhX
* out	d0.l	FDC Xe[^X
* break	d2-d3/a1
* l:
*	_B_READDL ƃR[hpĂ.

b_read_sasi:
		jmp	([orig_iocs_b_read,pc])

iocs_b_read:
		btst	#4+8,d1
		beq	b_read_sasi		;SASI

		FDD_MOTOR_ON
		PUSH	d1/d4-d7/a2
		GET_FD_PARAM			;ZN^Ƃ̒萔l		
		tst.l	d0
		bne	b_read_error

		FD_SEEK
		btst	#ST0_NR+24,d0
		bne	b_read_error

		and.b	#FDC_MT+FDC_MF,d1
		ori.b	#FDC_READ_DATA,d1
b_read_loop:
		MAKE_FDC_CMD			;FDCւ̃R}hobt@ɓWJ
		rol.l	#8,d2
		addq.l	#2,a0
		move.l	d2,(a0)+		;ZN^ID
		ror.l	#8,d2
		move.b	d2,(a0)+		;ŏIZN^ԍ͊JnƓ
		move.b	d7,(a0)+		;Gap3 ǂݔ΂oCg
		move.b	d6,(a0)			;Data 

* f[^ǂݍ
		MASK_INT
		WRITE_FDC_CMD9			;FDCɃR}h

		movem.l	d4-d5/a1-a3,-(sp)
		lea	(FDC_STAT),a2
		lea	(FDC_DATA-FDC_STAT,a2),a3
		moveq	#$f0,d4
@@:
		cmp.b	(a2),d4			;$f* ɂȂ܂ő҂
		bhi	@b
		move.b	(a3),(a1)+		;1 oCgǂݍ
		subq	#1,d5
		bne	@b

		WAIT_BUSY_OFF (a2)		;슮҂
		movem.l	(sp)+,d4-d5/a1-a3
		UMASK_INT
		SENSE_INT_STAT			;Xe[^Xǂݍ

		bsr	get_result_stat		;UgXe[^X𓾂
		btst	#ST2_CM+8,d0
		bne	@f			;DDAMo
		btst	#ST0_IC0+24,d0
		beq	b_read_end
		btst	#ST0_NR+24,d0
		bne	b_read_error		;Not Ready
@@:
		FDD_RETRY
		dbra	d4,b_read_loop
b_read_error:
		POP	d1/d4-d7/a2
		FDD_MOTOR_OFF
		rts

b_read_end:
		lea	(b_read_table,pc),a2
		FD_REPEAT			;JԂ
b_read_table:
		.dc	b_read_error-b_read_table
		.dc	b_read_loop-b_read_table
		.dc	b_read_loop-b_read_table


* IOCS _B_FORMAT ------------------------------ *
* in	d1.hb	PDA
*	d1.b	[h
*	d2.l	ړItH[}bgʒu
*	d3.l	ID f[^̃oCg
*	a1.l	ID f[^̃AhX
* out	d0.l	FDC Xe[^X

b_format_sasi:
		jmp	([orig_iocs_b_format,pc])

iocs_b_format:
		btst	#4+8,d1
		beq	b_format_sasi		;SASI

		FDD_MOTOR_ON
		PUSH	d1/d4-d6

		move	d1,d0
		lsr	#8,d0
		lsr	#5,d0			; 3 bit
		lea	($ff8f68),a0
		move	(a0,d0.w*2),d0
		adda	d0,a0
		bne	b_format_have_pda
* ` PDA
		move.l	(EXPDA_VEC),d0
		beq	b_format_error		;g PDA ͖o^

		movea.l	d0,a0
		moveq	#1,d0			;1=p̒萔\𓾂
		jsr	(a0)			;g PDA ̕\̃AhX𓾂
b_format_have_pda:
		move.l	d2,d4
		swap	d4
		lsr	#8,d4
		cmp	(a0)+,d4
		bhi	b_format_error

		lsl	#2,d4
		adda	d4,a0			;ZN^Ƃ̒萔\
		btst	#6,d1
		beq	@f			;FM
		addq.l	#2,a0			;MFM
@@:
		moveq	#0,d6
		move	(a0),d6
		beq	b_format_error		;FM  N=3AMFM  N=0 ͎ws

		moveq	#0,d5
		move	d6,d5
		lsr	#8,d5
		asl.l	#2,d5			;ZN^x4=ID̑傫
		asl.l	#8,d6			; 0 | SC | GPL | 0

		move.l	d2,d4
		and.l	#$ff0000ff,d4
		or.l	d4,d6			; N | SC | GPL | D

		FD_SEEK
		btst	#ST0_NR+24,d0
		bne	b_format_end

		and.b	#FDC_MT+FDC_MF,d1
		or.b	#FDC_WRITE_ID,d1
		MAKE_FDC_CMD

		move.l	d6,(2,a0)		;p[^Zbg
b_format_loop:
* f[^
		moveq	#6-1,d0
		lea	(FDCMD),a0
		MASK_INT
		WRITE_FDC_CMD

		movem.l	d4-d5/a1-a3,-(sp)
		lea	(FDC_STAT),a2
		lea	(FDC_DATA-FDC_STAT,a2),a3
		moveq	#$b0,d4
@@:
		moveq	#$f0,d0
		and.b	(a2),d0
		cmp.b	d4,d0			;$b* ɂȂ܂ő҂
		bne	@b
		move.b	(a1)+,(a3)		;1 oCg
		subq	#1,d5
		bne	@b

		WAIT_BUSY_OFF (a2)		;슮҂
		movem.l	(sp)+,d4-d5/a1-a3
		UMASK_INT
		SENSE_INT_STAT			;Xe[^Xǂݍ

		bsr	get_result_stat		;UgXe[^X𓾂
		btst	#ST0_IC0+24,d0
		beq	b_format_end
		btst	#ST0_NR+24,d0
		bne	b_format_end
		btst	#ST1_NW+16,d0
		bne	b_format_end

		FDD_RETRY
		dbra	d4,b_format_loop
b_format_end:
		POP	d1/d4-d6
		FDD_MOTOR_OFF
		rts

b_format_error:
		moveq	#-1,d0
		bra	b_format_end


* IOCS _B_WRITED ------------------------------ *
* in	d1.hb	PDA
*	d1.b	[h
*	d2.l	ړI݈ʒu
*	d3.l	oCg
*	a1.l	f[^AhX
* out	d0.l	FDC Xe[^X
* break	d2-d3/a1
* l:
*	_B_WRITE ƃR[hpĂ.

b_writed_sasi:
		jmp	([orig_iocs_b_writed,pc])

iocs_b_writed:
		btst	#4+8,d1
		beq	b_writed_sasi		;SASI

		FDD_MOTOR_ON
		PUSH	d1/d4-d7/a2
		GET_FD_PARAM			;ZN^Ƃ̒萔l		
		tst.l	d0
		bne	b_write_error

		FD_SEEK
		btst	#ST0_NR+24,d0
		bne	b_write_error

		and.b	#FDC_MT+FDC_MF,d1
		ori.b	#FDC_WRITE_DELETED_DATA,d1
		bra	b_write_loop		; _B_WRITE Ɠ


* IOCS _B_READDL ------------------------------ *
* in	d1.hb	PDA
*	d1.b	[h
*	d2.l	ړIǂݍ݈ʒu
*	d3.l	oCg
*	a1.l	obt@AhX
* out	d0.l	FDC Xe[^X
* break	d2-d3/a1
* l:
*	_B_READ ƃR[hpĂ.

b_readdl_sasi:
		jmp	([orig_iocs_b_readdl,pc])

iocs_b_readdl:
		btst	#4+8,d1
		beq	b_readdl_sasi		;SASI

		FDD_MOTOR_ON
		PUSH	d1/d4-d7/a2
		GET_FD_PARAM			;ZN^Ƃ̒萔l		
		tst.l	d0
		bne	b_read_error

		FD_SEEK
		btst	#ST0_NR+24,d0
		bne	b_read_error

		and.b	#FDC_MT+FDC_MF,d1
		ori.b	#FDC_READ_DELETED_DATA,d1
		bra	b_read_loop		; _B_READ Ɠ


* Tu[` -------------------------------- *

* UgXe[^X𓾂 -------------------- *
* in	d1.w	PDA
* out	d0.l	Xe[^X(ST0/ST1/ST2/C)
*	a0.l	Xe[^Xi[obt@̃AhX

get_result_stat:
		move	d1,d0
		clr.b	d0
		lsl	#6,d0
		rol	#5,d0			;FDC_RESULT_SIZE*drive no.
		lea	(FDC_RESULT),a0
		adda	d0,a0
		move.l	(a0),d0
.if 1
.if 0
		bmi	@f
		btst	#ST0_IC0+24,d0
		beq	@f
		btst	#ST1_OR+16,d0		;Over Run Ă
		beq	@f			;G[𖳎
.endif
		andi.l	#$bfefffff,d0
		move.l	d0,(a0)
@@:
.endif
		rts


		.ifdef	HAVE_FDD_MOTOR_ON
		.fail	1
fdd_motor_on:
		rts
		.endif

		.ifdef	HAVE_GET_FD_PARAM
		.fail	1
get_fd_param:
		rts
		.endif

		.ifdef	HAVE_FD_SEEK
		.fail	1
fd_seek:
		rts
		.endif

		.ifdef	HAVE_MAKE_FDC_CMD
		.fail	1
make_fdc_cmd:
		rts
		.endif

		.ifdef	HAVE_WRITE_FDC_CMD9
		.fail	1
write_fdc_cmd9:
		rts
		.endif

		.ifdef	HAVE_WRITE_FDC_CMD
		.fail	1
write_fdc_cmd:
		rts
		.endif

		.ifdef	HAVE_FDD_RETRY
		.fail	1
fdd_retry:
		rts
		.endif

		.ifdef	HAVE_FDD_MOTOR_OFF
		.fail	1
fdd_motor_off:
		rts
		.endif

		.ifdef	HAVE_FD_REPEAT
		.fail	1
fd_repeat:
		rts
		.endif

		.ifdef	HAVE_SENSE_INT_STAT
		.fail	1
sense_int_stat:
		rts
		.endif

		.ifdef	HAVE_INS_EJE_CHECK
		.fail	1
ins_eje_check:
		rts
		.endif

		.ifdef	HAVE_WAIT_5NS
		.fail	1
wait_5ns:
		rts
		.endif


		.end

* ȉ IOCS R[yъ荞ݏ DMA gp
* Ȃ߁AtbNKv͂Ȃ.

* IOCS _B_SEEK($40)
* IOCS _B_DRVSNS($44)
* IOCS _B_RECALI($47)
* IOCS _B_ASSIGN($48)	(FD ɑ΂Ă͎gps)
* IOCS _B_READID($4a)
* IOCS _B_BADFMT($4b)	(V)
* IOCS _B_DRVCHK($4e)
* IOCS _B_EJECT($4f)

* FDC Xe[^X荞($60)
* FDC }/ro荞($61)
* DMAC#0 I($64)
* DMAC#0 G[($65)

* End of File --------------------------------- *
