		.title	dmapurge - pcmio


* Include File -------------------------------- *

		.include	macro.mac
		.include	iomap.mac
		.include	vector.mac
		.include	iocscall.mac
		.include	iocswork.mac

		.include	dmapurge.mac


* Macro --------------------------------------- *

CLR_DMA_WORK:	.macro
		clr	(PCMMOD)
**		clr.b	(PCMERR)
		.endm

PCM_WAIT:	.macro
		.local	loop
loop:
		tst.b	(PCMMOD)
		bne	loop
.if 0
		jsr	($ff83b2)
.endif
		.endm

WAIT_PCL_INIT:	.macro	dn,an
		lea	(DMAC_CH3+~DMAC_CSR),an
		moveq	#0,dn			;PCL CXe[^X̃rbgʒu
~bit:		.reg	dn
~ea:		.reg	(an)
		.endm

WAIT_PCL_LOW:	.macro
		.local	loop
loop:
		btst	~bit,~ea
		bne	loop
		.endm

WAIT_PCL_HIGH:	.macro
		.local	loop
loop:
		btst	~bit,~ea
		beq	loop
		.endm


* Text Section -------------------------------- *

		.cpu	68020

		.text


* xN^e[u ------------------------------ *

		.quad
pcmio_hook_table::
		IOCSV	_ADPCMOUT,	iocs_adpcmout
		IOCSV	_ADPCMINP,	iocs_adpcminp
		IOCSV	_ADPCMAOT,	iocs_adpcmaot
		IOCSV	_ADPCMAIN,	iocs_adpcmain
		IOCSV	_ADPCMLOT,	iocs_adpcmlot
		IOCSV	_ADPCMLIN,	iocs_adpcmlin
		IOCSV	_ADPCMSNS,	iocs_adpcmsns
		IOCSV	_ADPCMMOD,	iocs_adpcmmod
		INTV	DMA3END_VEC,	int_dma3end
		INTV	DMA3ERR_VEC,	int_dma3err
		V_END


* IOCS _ADPCMOUT($60) ------------------------- *
* in	d1.w	bit 15=0:ʏ
*		       1:m[EFCg
*		bit 10~8:TvOg
*			 0=3.9kHz 1=5.2kHz 2=7.8kHz 3=10.4kHz 4=15.6kHz
*		bit  1~0:p|bg
*			 0=Ȃ 1= 2=E 3=
*	d2.l	oCg
*	a1.l	obt@AhX
* out	d0.l	j
*	d2.l	 0
*	a1.l	I̓]AhX
* break	a0
* l:
*	ĐJnOɃEFCg͓Ȃ.

iocs_adpcmout::
		move.l	a2,-(sp)
		PCM_WAIT
		move.b	#$02,(PCMMOD)
		bsr	set_adpcm_mode
		MASK_INT

		WAIT_PCL_INIT	d0,a2
		lea	(ADPCM_DATA),a0
		move.b	#%010,(ADPCM_CMD-ADPCM_DATA,a0)	;ĐJn
		tst.l	d2
		beq	adpcmout_end
adpcmout_loop:
		WAIT_PCL_LOW
		move.b	(a1)+,(a0)		;1 oCg]
		WAIT_PCL_HIGH
		subq.l	#1,d2
		bne	adpcmout_loop
adpcmout_end:
		WAIT_PCL_LOW
		move.b	#$80,(a0)		;f[^
		WAIT_PCL_HIGH

		UMASK_INT
		CLR_DMA_WORK
		movea.l	(sp)+,a2
		rts


* ADPCM ̃TvOgAp|bgݒ肷.
* in	d1.w	bit 10~8:TvOg
*			 0=3.9kHz 1=5.2kHz 2=7.8kHz 3=10.4kHz 4=15.6kHz
*		bit  1~0:p|bg
*			 0=Ȃ 1= 2=E 3=

set_adpcm_mode:
		PUSH	d0-d1
		move	d1,-(sp)
		lsr	#8,d1			;g

		moveq	#$7f,d0			;{NbN̑I
		and.b	(OPM1B_SAVE),d0
		subq	#%010,d1
		bcc	@f			;7.8kHz ȏ 8MHz
		addq	#%010,d1
		tas	d0			;	 4MHz
@@:
		move.b	d0,(OPM1B_SAVE)

		bsr	opm_wait		;OPM $1b ɏ
		move.b	#$1b,(OPM_REGNO)
		bsr	opm_wait
		move.b	d0,(OPM_DATA)

		moveq	#$f0,d0
		and.b	(JOYSTICK_CTRL),d0	;̃rbg͓
		andi	#%11,d1
		lsl.b	#2,d1
		or.b	d1,d0			;g
		moveq	#%11,d1
		and	(sp)+,d1
		or.b	(pan_table,pc,d1.w),d0	;
		move.b	d0,(JOYSTICK_CTRL)

		POP	d0-d1
		rts

pan_table:	*	 --, -R, L-, LR
		.dc.b	%11,%01,%10,%00
		.even


* OPM ̃ANZXɑ΂ăEFCg.
* X68030 ł͌Xn[hEFAŃEFCgʂɓĂ̂
* Xe[^XWX^̎QƎ̂̓EFCg͕sv.

opm_wait:
		tst.b	(OPM_STAT)
		bmi	opm_wait
		rts


* IOCS _ADPCMINP($61) ------------------------- *
* in	d1.w	bit 15=0:ʏ
*		       1:m[EFCg
*		bit 10~8:TvOg
*			 0=3.9kHz 1=5.2kHz 2=7.8kHz 3=10.4kHz 4=15.6kHz
*		bit  1~0:p|bg
*			 0=Ȃ 1= 2=E 3=
*	d2.l	oCg
*	a1.l	obt@AhX
* out	d0.l	j
*	d2.l	 0
*	a1.l	I̓]AhX
* break	a0
* l:
*	^JnOɃEFCg͓Ȃ.

iocs_adpcminp::
		move.l	a2,-(sp)
		PCM_WAIT
		move.b	#$04,(PCMMOD)
		bsr	set_adpcm_mode
		MASK_INT

		WAIT_PCL_INIT	d0,a2
		lea	(ADPCM_DATA),a0
		move.b	#%100,(ADPCM_CMD-ADPCM_DATA,a0)	;^Jn
		tst.l	d2
		beq	adpcminp_end
adpcminp_loop:
		WAIT_PCL_LOW
		move.b	(a0),(a1)+		;1 oCg]
		WAIT_PCL_HIGH
		subq.l	#1,d2
		bne	adpcminp_loop
adpcminp_end:
		UMASK_INT
		CLR_DMA_WORK
		movea.l	(sp)+,a2
		rts


* IOCS _ADPCMAOT($62) ------------------------- *
* in	d1.w	bit 15=0:ʏ
*		       1:m[EFCg
*		bit 10~8:TvOg
*			 0=3.9kHz 1=5.2kHz 2=7.8kHz 3=10.4kHz 4=15.6kHz
*		bit  1~0:p|bg
*			 0=Ȃ 1= 2=E 3=
*	d2.l	AC`F[e[ǔ
*	a1.l	V			AhX(])
* break	d0/a0
* l:
*	ĐJnOɃEFCg͓Ȃ.

iocs_adpcmaot::
		PUSH	d1-d2/a1-a3
		PCM_WAIT
		move.b	#$12,(PCMMOD)
		bsr	set_adpcm_mode
		MASK_INT

		WAIT_PCL_INIT	d0,a2
		lea	(ADPCM_DATA),a0
		move.b	#%010,(ADPCM_CMD-ADPCM_DATA,a0)	;ĐJn
		tst.l	d2
		beq	adpcmaot_end
adpcmaot_loop_t:
		movea.l	(a1)+,a3		;]AhX
		move	(a1)+,d1		;oCg
		beq	adpcmaot_next
adpcmaot_loop:
		WAIT_PCL_LOW
		move.b	(a3)+,(a0)		;1 oCg]
		WAIT_PCL_HIGH
		subq	#1,d1
		bne	adpcmaot_loop
adpcmaot_next:
		subq.l	#1,d2
		bne	adpcmaot_loop_t
adpcmaot_end:
		WAIT_PCL_LOW
		move.b	#$80,(a0)		;f[^
		WAIT_PCL_HIGH

		UMASK_INT
		CLR_DMA_WORK
		POP	d1-d2/a1-a3
		rts


* IOCS _ADPCMAIN($63) ------------------------- *
* in	d1.w	bit 15=0:ʏ
*		       1:m[EFCg
*		bit 10~8:TvOg
*			 0=3.9kHz 1=5.2kHz 2=7.8kHz 3=10.4kHz 4=15.6kHz
*		bit  1~0:p|bg
*			 0=Ȃ 1= 2=E 3=
*	d2.l	AC`F[e[ǔ
*	a1.l	V			AhX(])
* break	d0/a0
* l:
*	ĐJnOɃEFCg͓Ȃ.

iocs_adpcmain::
		PUSH	d1-d2/a1-a3
		PCM_WAIT
		move.b	#$14,(PCMMOD)
		bsr	set_adpcm_mode
		MASK_INT

		WAIT_PCL_INIT	d0,a2
		lea	(ADPCM_DATA),a0
		move.b	#%100,(ADPCM_CMD-ADPCM_DATA,a0)	;^Jn
		tst.l	d2
		beq	adpcmain_end
adpcmain_loop_t:
		movea.l	(a1)+,a3		;]AhX
		move	(a1)+,d1		;oCg
		beq	adpcmain_next
adpcmain_loop:
		WAIT_PCL_LOW
		move.b	(a0),(a3)+		;1 oCg]
		WAIT_PCL_HIGH
		subq	#1,d1
		bne	adpcmain_loop
adpcmain_next:
		subq.l	#1,d2
		bne	adpcmain_loop_t
adpcmain_end:
		UMASK_INT
		CLR_DMA_WORK
		POP	d1-d2/a1-a3
		rts


* IOCS _ADPCMLOT($64) ------------------------- *
* in	d1.w	bit 15=0:ʏ
*		       1:m[EFCg
*		bit 10~8:TvOg
*			 0=3.9kHz 1=5.2kHz 2=7.8kHz 3=10.4kHz 4=15.6kHz
*		bit  1~0:p|bg
*			 0=Ȃ 1= 2=E 3=
*	a1.l	NAC`F[e[ũAhX(])
* break	d0/a0
* l:
*	ĐJnOɃEFCg͓Ȃ.

iocs_adpcmlot::
		PUSH	d1/a1-a3
		PCM_WAIT
		move.b	#$22,(PCMMOD)
		bsr	set_adpcm_mode
		MASK_INT

		WAIT_PCL_INIT	d0,a2
		lea	(ADPCM_DATA),a0
		move.b	#%010,(ADPCM_CMD-ADPCM_DATA,a0)	;ĐJn
		move.l	a1,d1
		beq	adpcmlot_end
adpcmlot_loop_t:
		movea.l	d1,a1
		movea.l	(a1)+,a3		;]AhX
		move	(a1)+,d1		;oCg
		beq	adpcmlot_next
adpcmlot_loop:
		WAIT_PCL_LOW
		move.b	(a3)+,(a0)		;1 oCg]
		WAIT_PCL_HIGH
		subq	#1,d1
		bne	adpcmlot_loop
adpcmlot_next:
		move.l	(a1)+,d1
		bne	adpcmlot_loop_t
adpcmlot_end:
		WAIT_PCL_LOW
		move.b	#$80,(a0)		;f[^
		WAIT_PCL_HIGH

		UMASK_INT
		CLR_DMA_WORK
		POP	d1/a1-a3
		rts


* IOCS _ADPCMLIN($65) ------------------------- *
* in	d1.w	bit 15=0:ʏ
*		       1:m[EFCg
*		bit 10~8:TvOg
*			 0=3.9kHz 1=5.2kHz 2=7.8kHz 3=10.4kHz 4=15.6kHz
*		bit  1~0:p|bg
*			 0=Ȃ 1= 2=E 3=
*	a1.l	NAC`F[e[ũAhX(])
* break	d0/a0
* l:
*	ĐJnOɃEFCg͓Ȃ.

iocs_adpcmlin::
		PUSH	d1/a1-a3
		PCM_WAIT
		move.b	#$24,(PCMMOD)
		bsr	set_adpcm_mode
		MASK_INT

		WAIT_PCL_INIT	d0,a2
		lea	(ADPCM_DATA),a0
		move.b	#%100,(ADPCM_CMD-ADPCM_DATA,a0)	;^Jn
		move.l	a1,d1
		beq	adpcmlin_end
adpcmlin_loop_t:
		movea.l	d1,a1
		movea.l	(a1)+,a3		;]AhX
		move	(a1)+,d1		;oCg
		beq	adpcmlin_next
adpcmlin_loop:
		WAIT_PCL_LOW
		move.b	(a0),(a3)+		;1 oCg]
		WAIT_PCL_HIGH
		subq	#1,d1
		bne	adpcmlin_loop
adpcmlin_next:
		move.l	(a1)+,d1
		bne	adpcmlin_loop_t
adpcmlin_end:
		UMASK_INT
		CLR_DMA_WORK
		POP	d1/a1-a3
		rts


* IOCS _ADPCMSNS($66) ------------------------- *
* out	d0.l	$00: sĂȂ
*		$02: IOCS _ADPCMOUT s
*		$04: IOCS _ADPCMINP V
*		$12: IOCS _ADPCMAOT V
*		$14: IOCS _ADPCMAIN V
*		$22: IOCS _ADPCMLOT V
*		$24: IOCS _ADPCMLIN V
* l:
*	]tO(bit 7)̓}XN.

iocs_adpcmsns::
		moveq	#$7f,d0
		and.b	(PCMMOD),d0
		rts


* IOCS _ADPCMMOD($67) ------------------------- *
* in	d1.l	0=I 1=f 2=ĊJ
* out	d0.l	0=I -1=s
* l:
*	ĊJ̏ꍇ d0.l = -1 ԂǂmȂ.

iocs_adpcmmod::
		tst.b	d1
		beq	adpcmmod_0
		cmpi.b	#2,d1
		bcs	adpcmmod_1
		beq	adpcmmod_2
*adpcmmod_error:
		moveq	#-1,d0
		rts

adpcmmod_0:
		CLR_DMA_WORK
adpcmmod_1:
		bsr	mute_adpcm
adpcmmod_2:
		moveq	#0,d0
		rts


* ADPCM ̍Đ~.
* ۂɂ͖f[^ĐĂ.

mute_adpcm:
		tst.b	(ADPCM_STAT)
		bmi	mute_adpcm_end		;^/ҋ@Ȃ牽Ȃ
		move.b	#$80,(ADPCM_DATA)
mute_adpcm_end:
		rts


* DMA #3 ]I($6a)/ُI($6b) ---------- *
* l:
*	̊荞݂ꍇ DMAC 
*	Ȃ΂ȂȂAvO̖ړI DMA
*	̊Srł̂ŁAł͉Ȃ.

int_dma3end::
int_dma3err::
		bsr	mute_adpcm
		clr.b	(PCMERR)		;G[Ȃ
		clr.b	(PCMMOD)
		rts


		.end

* End of File --------------------------------- *
