		.title	srambuf - dmamove


* Include File -------------------------------- *

		.include	macro.mac
		.include	vector.mac
		.include	iocscall.mac
		.include	iocswork.mac

		.include	srambuf.mac


* Text Section -------------------------------- *

.ifdef X68030
		.cpu	68020
.else
		.cpu	68000
.endif

		.text
		.even


* xN^e[u ------------------------------ *

		.quad
dmamove_hook_table::
		IOCSV	_DMAMOVE,	iocs_dmamove
		IOCSV	_DMAMOV_A,	iocs_dmamov_a
		IOCSV	_DMAMOV_L,	iocs_dmamov_l
		IOCSV	_DMAMODE,	iocs_dmamode
		INTV	DMA2END_VEC,	int_dma2end
		INTV	DMA2ERR_VEC,	int_dma2err
		V_END


* IOCS _DMAMOVE($8a) -------------------------- *
* in	d1.b	bit 7=0:a1 -> a2
*		      1:a2 -> a1
*		bit 3~2=0:a1 Œ
*			1:a1++
*			2:a1--		3:w֎~
*		bit 1~0=0:a2 Œ
*			1:a2++
*			2:a2--		3:w֎~
*	d2.l	]oCg
*	a1.l	]AhX
*	a2.l	]V
* out	d0.l	j
*	d2.l	 0
*	a1.l	I̓]AhX
*	a2.l	I̓]AhX

iocs_dmamove::
		tst.l	d2
		beq	dmamove_end

		move.b	d1,d0
		bpl	@f			;a1 to a2
		exg	a1,a2			;a2 to a1
		move	d0,-(sp)
		lsl	#4,d0
		move.b	d0,(sp)
		move	(sp)+,d0
		rol	#2,d0
@@:
		andi	#%1111,d0
.ifdef X68030
		move	(@f,pc,d0.w*2),d0
.else
		add	d0,d0
		move	(@f,pc,d0.w),d0
.endif
		jmp	(@f,pc,d0.w)
@@:
		.dc	dmamove_const_const-@b
		.dc	dmamove_const_plus-@b
		.dc	dmamove_const_minus-@b
		.dc	dmamove_const_error-@b
		.dc	dmamove_plus_const-@b
		.dc	dmamove_plus_plus-@b
		.dc	dmamove_plus_minus-@b
		.dc	dmamove_plus_error-@b
		.dc	dmamove_minus_const-@b
		.dc	dmamove_minus_plus-@b
		.dc	dmamove_minus_minus-@b
		.dc	dmamove_minus_error-@b
		.dc	dmamove_error_const-@b
		.dc	dmamove_error_plus-@b
		.dc	dmamove_error_minus-@b
		.dc	dmamove_error_error-@b

COPY:		.macro	src,dst
		.local	loop
loop:		move.b	src,dst
		subq.l	#1,d2
		bne	loop
		.endm

dmamove_const_const:
dmamove_const_error:
dmamove_error_const:
dmamove_error_error:
		COPY	(a1),(a2)
dmamove_end:
		rts

dmamove_const_plus:
dmamove_error_plus:
		COPY	(a1),(a2)+
		rts

dmamove_const_minus:
dmamove_error_minus:
		addq.l	#1,a2
		COPY	(a1),-(a2)
		subq.l	#1,a2
		rts

dmamove_plus_const:
dmamove_plus_error:
		COPY	(a1)+,(a2)
		rts

dmamove_plus_plus:
		COPY	(a1)+,(a2)+
		rts

dmamove_plus_minus:
		addq.l	#1,a2
		COPY	(a1)+,-(a2)
		subq.l	#1,a2
		rts

dmamove_minus_const:
dmamove_minus_error:
		addq.l	#1,a1
		COPY	-(a1),(a2)
		subq.l	#1,a1
		rts

dmamove_minus_plus:
		addq.l	#1,a1
		COPY	-(a1),(a2)+
		subq.l	#1,a1
		rts

dmamove_minus_minus:
		addq.l	#1,a1
		addq.l	#1,a2
		COPY	-(a1),-(a2)
		subq.l	#1,a1
		subq.l	#1,a2
		rts

COPY:		.macro
		.fail	1
		.endm


* IOCS _DMAMOV_A($8b) ------------------------- *
* in	d1.b	bit 7=0:a1 -> a2
*		      1:a2 -> a1
*		bit 3~2=0:a1 Œ
*			1:a1++
*			2:a1--		3:w֎~
*		bit 1~0=0:a2 Œ
*			1:a2++
*			2:a2--		3:w֎~
*	d2.l	AC`F[e[ǔ
*	a1.l	AC`F[e[ũAhX
*	a2.l	]AhX
* l:
*	d0/a0 ȊÕWX^͔j󂳂Ȃ.

iocs_dmamov_a::
		PUSH	d2-d3/a1-a2
		move.l	d2,d3			;
		beq	dmamov_a_end
		lea	(a1),a0			;AC`F[e[u
dmamov_a_loop:
		movea.l	(a0)+,a1		;]AhX
		moveq	#0,d2
		move	(a0)+,d2		;oCg
**		beq	dmamov_a_next

		bsr	iocs_dmamove
		tst.b	d1
		bpl	dmamov_a_next
		exg	a1,a2
dmamov_a_next:
		subq.l	#1,d3
		bne	dmamov_a_loop
dmamov_a_end:
		POP	d1-d2/a1-a2
		rts


* IOCS _DMAMOV_L($8c) ------------------------- *
* in	d1.b	bit 7=0:a1 -> a2
*		      1:a2 -> a1
*		bit 3~2=0:a1 Œ
*			1:a1++
*			2:a1--		3:w֎~
*		bit 1~0=0:a2 Œ
*			1:a2++
*			2:a2--		3:w֎~
*	a1.l	`F[e[ũAhX
*	a2.l	]AhX
* l:
*	d0/a0 ȊÕWX^͔j󂳂Ȃ.

iocs_dmamov_l::
		PUSH	d2/a1-a2
		move.l	a1,d0			;`F[e[u
		beq	dmamov_l_end
dmamov_l_loop:
		movea.l	d0,a0
		movea.l	(a0)+,a1		;]AhX
		moveq	#0,d2
		move	(a0)+,d2		;oCg
**		beq	dmamov_l_next

		bsr	iocs_dmamove
		tst.b	d1
		bpl	dmamov_l_next
		exg	a1,a2
dmamov_l_next:
		move.l	(a0)+,d0		;̃e[u
		bne	dmamov_l_loop
dmamov_l_end:
		POP	d2/a1-a2
		rts


* IOCS _DMAMODE($8d) -------------------------- *
* out	d0.l	$00: sĂȂ
*		$8a: IOCS _DMAMOVE s
*		$8b: IOCS _DMAMOV_A V
*		$8c: IOCS _DMAMOV_L V
* l:
*	tbNKv͂Ȃꉞ.

iocs_dmamode::
		moveq	#0,d0
		move.b	(DMA2MOD),d0
		rts


* DMA #2 ]I($68)/ُI($69) ---------- *
* l:
*	̊荞݂ꍇ DMAC 
*	Ȃ΂ȂȂAvO̖ړI DMA
*	̊Srł̂ŁAł͉Ȃ.

int_dma2end::
int_dma2err::
		clr.b	(DMA2ERR)		;G[Ȃ
		clr.b	(DMA2MOD)
		rts


		.end

* End of File --------------------------------- *
