		.title	srambuf - fddio


* Include File -------------------------------- *

		.include	macro.mac
		.include	iomap.mac
		.include	iocscall.mac
		.include	iocswork.mac

		.include	srambuf.mac


* Macro --------------------------------------- *

CHECK:		.macro	label
		btst	#4+8,d1
		beq	label			;SASI
		cmpi.l	#4<<24,d2
		bcc	label			;ZN^傫
		.endm

JMP_ORIG:	.macro	label
.ifdef X68030
		jmp	([label,pc])
.else
		move.l	(label,pc),-(sp)
		rts
.endif
		.endm


GET_RESULT_STAT:.macro
		.ifdef	HAVE_GET_RESULT_STAT
		bsr	get_result_stat
		.else
.ifdef X68030
		jsr	($ff8a80)
.else
		jsr	($ff8fac)
.endif
		.endif
		.endm

FDD_MOTOR_ON:	.macro
		.ifdef	HAVE_FDD_MOTOR_ON
		bsr	fdd_motor_on
		.else
.ifdef X68030
		jsr	($ff8ed6)
.else
		jsr	($ff93e6)
.endif
		.endif
		.endm

GET_FD_PARAM:	.macro
		.ifdef	HAVE_GET_FD_PARAM
		bsr	get_fd_param
		.else
.ifdef X68030
		jsr	($ff8dc0)
.else
		jsr	($ff92f6)
.endif
		.endif
		.endm

FD_SEEK:	.macro
		.ifdef	HAVE_FD_SEEK
		bsr	fd_seek
		.else
.ifdef X68030
		jsr	($ff8e04)
.else
		jsr	($ff9338)
.endif
		.endif
		.endm

MAKE_FDC_CMD:	.macro
		.ifdef	HAVE_MAKE_FDC_CMD
		bsr	make_fdc_cmd
		.else
.ifdef X68030
		jsr	($ff8e20)
.else
		jsr	($ff9356)
.endif
		.endif
		.endm

* IOCS [N FDCMD  9 oCg
WRITE_FDC_CMD9:	.macro
		.ifdef	HAVE_WRITE_FDC_CMD9
		bsr	write_fdc_cmd9
		.else
.ifdef X68030
		jsr	($ff8e9c)
.else
		lea	(FDCMD),a0
		moveq	#9-1,d0
		jsr	($ff93ac)
.endif
		.endif
		.endm

* IOCS [N FDCMD  d0.w oCg
WRITE_FDC_CMD:	.macro
		.ifdef	HAVE_WRITE_FDC_CMD
		bsr	write_fdc_cmd
		.else
.ifdef X68030
		jsr	($ff8e9e)
.else
		lea	(FDCMD),a0
		jsr	($ff93ac)
.endif
		.endif
		.endm

FDD_RETRY:	.macro
		.ifdef	HAVE_FDD_RETRY
		bsr	fdd_retry
		.else
.ifdef X68030
		jsr	($ff8a26)
.else
		jsr	($ff8f44)
.endif
		.endif
		.endm

FDD_MOTOR_OFF:	.macro
		.ifdef	HAVE_FDD_MOTOR_OFF
		bsr	fdd_motor_off
		.else
.ifdef X68030
		jsr	($ff8f54)
.else
		jsr	($ff944c)
.endif
		.endif
		.endm

.ifndef X68030
HAVE_FD_REPEAT:	.equ	1
.endif
FD_REPEAT:	.macro
		.ifdef	HAVE_FD_REPEAT
		bra	fd_repeat
		.else
.ifdef X68030
		jmp	($ff8d68)
.else
		.fail	1
.endif
		.endif
		.endm

WAIT_05MS:	.macro
		.ifdef	HAVE_WAIT_05MS
		bsr	wait_05ms
		.else
.ifdef X68030
		moveq	#12,d0
		jsr	($ff0d12)
.else
		move	(RAMCNT),d0
		lsr	#1,d0
@loop:		dbra	d0,@loop
.endif
		.endif
		.endm

WAIT_BUSY_OFF:	.macro
		.ifdef	HAVE_WAIT_BUSY_OFF
		bsr	wait_busy_off
		.else
.ifdef X68030
		jsr	($ff8e66)
.else
		jsr	($ff938a)
		jsr	($ff92d8)
.endif
		.endif
		.endm


* Constant ------------------------------------ *

* FDC̃R}h
FDC_READ_DIAGNOSTIC:		.equ	2
FDC_SPECIFY:			.equ	3
FDC_SENSE_DEVICE_STATUS:	.equ	4
FDC_WRITE_DATA:			.equ	5
FDC_READ_DATA:			.equ	6
FDC_RECALIBRATE:		.equ	7
FDC_SENSE_INTERRUPT_STATUS:	.equ	8
FDC_WRITE_DELETED_DATA:		.equ	9
FDC_READ_ID:			.equ	10
FDC_READ_DELETED_DATA:		.equ	12
FDC_WRITE_ID:			.equ	13
FDC_SEEK:			.equ	15
FDC_SCAN_EQUAL:			.equ	17

		.ifndef	FDC_MT
FDC_MT:		.equ	1<<7
FDC_MF:		.equ	1<<6
		.endif


* Text Section -------------------------------- *

.ifdef X68030
		.cpu	68020
.else
		.cpu	68000
.endif

		.text
		.even


* xN^e[u ------------------------------ *

		.quad
fddio_hook_table::
		IOCSV	_B_VERIFY,	iocs_b_verify
		IOCSV	_B_READDI,	iocs_b_readdi
		IOCSV	_B_WRITE,	iocs_b_write
		IOCSV	_B_READ,	iocs_b_read
		IOCSV	_B_FORMAT,	iocs_b_format
		IOCSV	_B_WRITED,	iocs_b_writed
		IOCSV	_B_READDL,	iocs_b_readdl
		V_END


* IOCS _B_VERIFY ------------------------------ *
* in	d1.hb	PDA
*	d1.b	[h
*	d2.l	ړIʒu
*	d3.l	oCg
*	a1.l	obt@AhX
* out	d0.l	FDC Xe[^X
* break	d2-d3/a1

b_verify_orig:
		JMP_ORIG orig_iocs_b_verify

iocs_b_verify::
		CHECK	b_verify_orig

		FDD_MOTOR_ON
		PUSH	d1/d4-d7/a2
		GET_FD_PARAM			;ZN^Ƃ̒萔l		
		tst.l	d0
		bne	b_verify_error

		FD_SEEK
		btst	#ST0_NR+24,d0
		bne	b_verify_error

		and.b	#FDC_MT+FDC_MF,d1
		or.b	#FDC_SCAN_EQUAL,d1
b_verify_loop:
		MAKE_FDC_CMD			;FDCւ̃R}hobt@ɓWJ
		rol.l	#8,d2
		addq.l	#2,a0
		move.l	d2,(a0)+		;ZN^ID
		ror.l	#8,d2
		move.b	d2,(a0)+		;ŏIZN^ԍ͊JnƓ
		move.b	d7,(a0)+		;Gap3 ǂݔ΂oCg
		move.b	d6,(a0)			;Data 

		bsr	dma_start_m2d		;DMA#0 Jn
		WRITE_FDC_CMD9			;FDCɃR}h
		WAIT_BUSY_OFF			;FDC/FDn Busy IG[܂őҋ@

		GET_RESULT_STAT
		btst	#ST2_SN+8,d0
		bne	b_verify_error		;SCAN R}hōŏIZN^܂
		btst	#ST0_IC0+24,d0		;𖞑Ȃ
		beq	b_verify_end
		btst	#ST0_NR+24,d0
		bne	b_verify_error		;Not Ready

		FDD_RETRY
		dbra	d4,b_verify_loop
b_verify_error:
		POP	d1/d4-d7/a2
		FDD_MOTOR_OFF
		rts

b_verify_end:
		lea	(b_verify_table,pc),a2
		FD_REPEAT			;JԂ
b_verify_table:
		.dc	b_verify_error-b_verify_table
		.dc	b_verify_loop-b_verify_table
		.dc	b_verify_loop-b_verify_table


* IOCS _B_READDI ------------------------------ *
* in	d1.hb	PDA
*	d1.b	[h
*	d2.l	ړIǂݍ݈ʒu
*	d3.l	oCg
*	a1.l	obt@AhX
* out	d0.l	FDC Xe[^X
* break	d2-d3/a1

b_readdi_orig:
		JMP_ORIG orig_iocs_b_readdi

iocs_b_readdi:
		CHECK	b_readdi_orig

		FDD_MOTOR_ON
		PUSH	d1/d4-d7/a2
		GET_FD_PARAM			;ZN^Ƃ̒萔l		
		tst.l	d0
		bne	b_readdi_error

		FD_SEEK
		btst	#ST0_NR+24,d0
		bne	b_readdi_error

		and.b	#FDC_MF,d1
		or.b	#FDC_READ_DIAGNOSTIC,d1
b_readdi_loop:
		MAKE_FDC_CMD			;FDCւ̃R}hobt@ɓWJ
		rol.l	#8,d2
		addq.l	#2,a0
		move.l	d2,(a0)+		;ZN^ID
		ror.l	#8,d2
		move.b	d2,(a0)+		;ŏIZN^ԍ͊JnƓ
		move.b	d7,(a0)+		;Gap3 ǂݔ΂oCg
		move.b	d6,(a0)			;Data 

		bsr	dma_start_d2m		;DMA#0 Jn
		WRITE_FDC_CMD9			;FDCɃR}h
		WAIT_BUSY_OFF			;FDC/FDn Busy IG[܂őҋ@
		bsr	dma_stop_d2m

		GET_RESULT_STAT
		move.l	#1<<(ST1_ND+16)+1<<(6+16)+1<<(7+8)+1<<(ST2_CM+8),d1
		and.l	d0,d1
		bne	b_readdi_end
		btst	#ST0_IC0+24,d0
		beq	b_readdi_end
		btst	#ST0_NR+24,d0
		bne	b_readdi_error		;Not Ready

		FDD_RETRY
		dbra	d4,b_readdi_loop
b_readdi_error:
		POP	d1/d4-d7/a2
		FDD_MOTOR_OFF
		rts

b_readdi_end:
		lea	(b_readdi_table,pc),a2
		FD_REPEAT			;JԂ
b_readdi_table:
		.dc	b_readdi_error-b_readdi_table
		.dc	b_readdi_loop-b_readdi_table
		.dc	b_readdi_loop-b_readdi_table


* IOCS _B_WRITE ------------------------------- *
* in	d1.hb	PDA
*	d1.b	[h
*	d2.l	ړI݈ʒu
*	d3.l	oCg
*	a1.l	f[^AhX
* out	d0.l	FDC Xe[^X
* break	d2-d3/a1
* l:
*	_B_WRITED ƃR[hpĂ.

b_write_orig:
		JMP_ORIG orig_iocs_b_write

iocs_b_write:
		CHECK	b_write_orig

		FDD_MOTOR_ON
		PUSH	d1/d4-d7/a2
		GET_FD_PARAM			;ZN^Ƃ̒萔l		
		tst.l	d0
		bne	b_write_error

		FD_SEEK
		btst	#ST0_NR+24,d0
		bne	b_write_error

		and.b	#FDC_MT+FDC_MF,d1
		or.b	#FDC_WRITE_DATA,d1
		bra	b_write_loop
b_write_loop_t:
		WAIT_05MS			;gbNړꍇ̓EFCg
b_write_loop:
		MAKE_FDC_CMD			;FDCւ̃R}hobt@ɓWJ
		rol.l	#8,d2
		addq.l	#2,a0
		move.l	d2,(a0)+		;ZN^ID
		ror.l	#8,d2
		move.b	d2,(a0)+		;ŏIZN^ԍ͊JnƓ
		move.b	d7,(a0)+		;Gap3 ǂݔ΂oCg
		move.b	d6,(a0)			;Data 

		bsr	dma_start_m2d		;DMA#0 Jn
		WRITE_FDC_CMD9			;FDCɃR}h
		WAIT_BUSY_OFF			;FDC/FDn Busy IG[܂őҋ@

		GET_RESULT_STAT
		btst	#ST0_IC0+24,d0
		beq	b_write_end
		btst	#ST0_NR+24,d0
		bne	b_write_error		;Not Ready
		btst	#ST1_NW+16,d0
		bne	b_write_error		;Not Writable(Write Protect)

		FDD_RETRY
		dbra	d4,b_write_loop
b_write_error:
		POP	d1/d4-d7/a2
		FDD_MOTOR_OFF
		rts

b_write_end:
		lea	(b_write_table,pc),a2
		FD_REPEAT			;JԂ
b_write_table:
		.dc	b_write_error-b_write_table
		.dc	b_write_loop-b_write_table
		.dc	b_write_loop_t-b_write_table


* IOCS _B_READ -------------------------------- *
* in	d1.hb	PDA
*	d1.b	[h
*	d2.l	ړIǂݍ݈ʒu
*	d3.l	oCg
*	a1.l	obt@AhX
* out	d0.l	FDC Xe[^X
* break	d2-d3/a1
* l:
*	_B_READDL ƃR[hpĂ.

b_read_orig:
		JMP_ORIG orig_iocs_b_read

iocs_b_read:
		CHECK	b_read_orig

		FDD_MOTOR_ON
		PUSH	d1/d4-d7/a2
		GET_FD_PARAM			;ZN^Ƃ̒萔l		
		tst.l	d0
		bne	b_read_error

		FD_SEEK
		btst	#ST0_NR+24,d0
		bne	b_read_error

		and.b	#FDC_MT+FDC_MF,d1
		or.b	#FDC_READ_DATA,d1
b_read_loop:
		MAKE_FDC_CMD			;FDCւ̃R}hobt@ɓWJ
		rol.l	#8,d2
		addq.l	#2,a0
		move.l	d2,(a0)+		;ZN^ID
		ror.l	#8,d2
		move.b	d2,(a0)+		;ŏIZN^ԍ͊JnƓ
		move.b	d7,(a0)+		;Gap3 ǂݔ΂oCg
		move.b	d6,(a0)			;Data 

		bsr	dma_start_d2m		;DMA#0 Jn
		WRITE_FDC_CMD9			;FDCɃR}h
		WAIT_BUSY_OFF			;FDC/FDn Busy IG[܂őҋ@
		bsr	dma_stop_d2m

		GET_RESULT_STAT
		btst	#ST2_CM+8,d0
		bne	@f			;DDAMo
		btst	#ST0_IC0+24,d0
		beq	b_read_end
		btst	#ST0_NR+24,d0
		bne	b_read_error		;Not Ready
@@:
		FDD_RETRY
		dbra	d4,b_read_loop
b_read_error:
		POP	d1/d4-d7/a2
		FDD_MOTOR_OFF
		rts

b_read_end:
		lea	(b_read_table,pc),a2
		FD_REPEAT			;JԂ
b_read_table:
		.dc	b_read_error-b_read_table
		.dc	b_read_loop-b_read_table
		.dc	b_read_loop-b_read_table


* IOCS _B_FORMAT ------------------------------ *
* in	d1.hb	PDA
*	d1.b	[h
*	d2.l	ړItH[}bgʒu
*	d3.l	ID f[^̃oCg
*	a1.l	ID f[^̃AhX
* out	d0.l	FDC Xe[^X

b_format_orig:
		JMP_ORIG orig_iocs_b_format

iocs_b_format:
		btst	#4+8,d1
		beq	b_format_orig		;SASI
		cmpi.l	#FDD_BUF_SIZE,d3
		bhi	b_format_orig		;ID f[^傫߂

		FDD_MOTOR_ON
		PUSH	d1/d4-d6

		move	d1,d0
		lsr	#8,d0
		lsr	#5,d0			; 3 bit
.ifdef X68030
		lea	($ff8f68),a0
		move	(a0,d0.w*2),d0
.else
		add	d0,d0
		lea	($ff9488),a0
		move	(a0,d0.w),d0
.endif
		adda	d0,a0
		bne	b_format_have_pda
* ` PDA
		move.l	(EXPDA_VEC),d0
		beq	b_format_error		;g PDA ͖o^

		movea.l	d0,a0
		moveq	#1,d0			;1=p̒萔\𓾂
		jsr	(a0)			;g PDA ̕\̃AhX𓾂
b_format_have_pda:
		move.l	d2,d4
		swap	d4
		lsr	#8,d4
		cmp	(a0)+,d4
		bhi	b_format_error

		lsl	#2,d4
		adda	d4,a0			;ZN^Ƃ̒萔\
		btst	#6,d1
		beq	@f			;FM
		addq.l	#2,a0			;MFM
@@:
		moveq	#0,d6
		move	(a0),d6
		beq	b_format_error		;FM  N=3AMFM  N=0 ͎ws

		moveq	#0,d5
		move	d6,d5
		lsr	#8,d5
		asl.l	#2,d5			;ZN^x4=ID̑傫
		asl.l	#8,d6			; 0 | SC | GPL | 0

		cmpi.l	#FDD_BUF_SIZE,d5
		bhi	b_format_error		;Ö׃`FbN

		move.l	d2,d4
		and.l	#$ff0000ff,d4
		or.l	d4,d6			; N | SC | GPL | D

		FD_SEEK
		btst	#ST0_NR+24,d0
		bne	b_format_end

		and.b	#FDC_MT+FDC_MF,d1
		or.b	#FDC_WRITE_ID,d1
		MAKE_FDC_CMD

		move.l	d6,(2,a0)		;p[^Zbg
b_format_loop:
		bsr	dma_start_m2d		;DMA#0 Jn
		moveq	#6-1,d0
		WRITE_FDC_CMD
		WAIT_BUSY_OFF			;FDC/FDn Busy IG[܂őҋ@

		GET_RESULT_STAT
		btst	#ST0_IC0+24,d0
		beq	b_format_end
		btst	#ST0_NR+24,d0
		bne	b_format_end
		btst	#ST1_NW+16,d0
		bne	b_format_end

		FDD_RETRY
		dbra	d4,b_format_loop
b_format_end:
		POP	d1/d4-d6
		FDD_MOTOR_OFF
		rts

b_format_error:
		moveq	#-1,d0
		bra	b_format_end


* IOCS _B_WRITED ------------------------------ *
* in	d1.hb	PDA
*	d1.b	[h
*	d2.l	ړI݈ʒu
*	d3.l	oCg
*	a1.l	f[^AhX
* out	d0.l	FDC Xe[^X
* break	d2-d3/a1
* l:
*	_B_WRITE ƃR[hpĂ.

b_writed_orig:
		JMP_ORIG orig_iocs_b_writed

iocs_b_writed:
		CHECK	b_writed_orig

		FDD_MOTOR_ON
		PUSH	d1/d4-d7/a2
		GET_FD_PARAM			;ZN^Ƃ̒萔l		
		tst.l	d0
		bne	b_write_error

		FD_SEEK
		btst	#ST0_NR+24,d0
		bne	b_write_error

		and.b	#FDC_MT+FDC_MF,d1
		or.b	#FDC_WRITE_DELETED_DATA,d1
		bra	b_write_loop		; _B_WRITE Ɠ


* IOCS _B_READDL ------------------------------ *
* in	d1.hb	PDA
*	d1.b	[h
*	d2.l	ړIǂݍ݈ʒu
*	d3.l	oCg
*	a1.l	obt@AhX
* out	d0.l	FDC Xe[^X
* break	d2-d3/a1
* l:
*	_B_READ ƃR[hpĂ.

b_readdl_orig:
		JMP_ORIG orig_iocs_b_readdl

iocs_b_readdl:
		CHECK	b_readdl_orig

		FDD_MOTOR_ON
		PUSH	d1/d4-d7/a2
		GET_FD_PARAM			;ZN^Ƃ̒萔l		
		tst.l	d0
		bne	b_read_error

		FD_SEEK
		btst	#ST0_NR+24,d0
		bne	b_read_error

		and.b	#FDC_MT+FDC_MF,d1
		or.b	#FDC_READ_DELETED_DATA,d1
		bra	b_read_loop		; _B_READ Ɠ


* Tu[` -------------------------------- *

* DMA#0 Jn ------------------------------ *
* in	d5.w	]Iyh
*	a1.l	AhX
* break	d0/a0
* l:
*	CȊOȂ DMA ]oƌȂA
*	SRAM Ƃ̂œ]s.

ADDR_CHECK:	.macro	label
.if 0
		cmpa.l	#$c00000,a1		;CH
		bcs	@skip
		cmpa.l	#$1000000,a1		;nCH
		bcs	label
@skip:
.endif
		.endm

* C FDC ɓ]
dma_start_m2d:
		ADDR_CHECK dma_start_m2d_orig

		move.l	a1,-(sp)
		lea	(FDD_BUF),a0
		move	d5,d0
		SRAM_WRITE_ENABLE
@@:		move.b	(a1)+,(a0)+		;]f[^ SRAM ɃRs[
		subq.w	#1,d0
		bne	@b
		SRAM_WRITE_DISABLE

		lea	(FDD_BUF),a1
		bsr	dma_start_m2d_orig	;SRAM  DMA ]
		movea.l	(sp)+,a1
		rts

dma_start_m2d_orig:
.ifdef X68030
		jmp	($ff8e42)
.else
		jmp	($ff92a0)
.endif

* FDC 烁Cɓ]
* SRAM ɏ܂āAI҂Ă烁C
* ]Ȃ΂ȂȂ.
* ł́ASRAM ݋Ԃɂ SRAM 
* obt@AhXZbg.
* DMA ~ dma_stop_d2m Ăяo.
dma_start_d2m:
		ADDR_CHECK dma_start_d2m_orig

		move.l	a1,-(sp)
		lea	(FDD_BUF),a1
		SRAM_WRITE_ENABLE
		bsr	dma_start_d2m_orig	;SRAM  DMA ]
		movea.l	(sp)+,a1
		rts

dma_start_d2m_orig:
.ifdef X68030
		jmp	($ff8e46)
.else
		jmp	($ff92b2)
.endif

* SRAM  DMA ]Ńf[^܂Ă̂ŁA
* Cɓ].
dma_stop_d2m:
		ADDR_CHECK dma_stop_d2m_end

		SRAM_WRITE_DISABLE
		move.l	a1,-(sp)
		lea	(FDD_BUF),a0
		move	d5,d0
@@:		move.b	(a0)+,(a1)+		;]f[^ SRAM Rs[
		subq.w	#1,d0
		bne	@b
		movea.l	(sp)+,a1
dma_stop_d2m_end:
		rts


		.ifdef	HAVE_GET_RESULT_STAT
		.fail	1
get_result_stat:
		rts
		.endif

		.ifdef	HAVE_FDD_MOTOR_ON
		.fail	1
fdd_motor_on:
		rts
		.endif

		.ifdef	HAVE_GET_FD_PARAM
		.fail	1
get_fd_param:
		rts
		.endif

		.ifdef	HAVE_FD_SEEK
		.fail	1
fd_seek:
		rts
		.endif

		.ifdef	HAVE_MAKE_FDC_CMD
		.fail	1
make_fdc_cmd:
		rts
		.endif

		.ifdef	HAVE_WRITE_FDC_CMD9
		.fail	1
write_fdc_cmd9:
		rts
		.endif

		.ifdef	HAVE_WRITE_FDC_CMD
		.fail	1
write_fdc_cmd:
		rts
		.endif

		.ifdef	HAVE_FDD_RETRY
		.fail	1
fdd_retry:
		rts
		.endif

		.ifdef	HAVE_FDD_MOTOR_OFF
		.fail	1
fdd_motor_off:
		rts
		.endif

		.ifdef	HAVE_FD_REPEAT
fd_repeat:
		btst	#ST0_IC1+24,d0
		bne	fd_repeat0		;foCXɏԑJڂ

		adda.l	d5,a1			;f[^|C^i߂
		sub.l	d5,d3
		bls	fd_repeat0		;c͂Ȃ

		move.l	d4,d0
		swap	d0
		move	d0,d4			;retry񐔂ݒ

		move	d7,d0
		lsr	#8,d0
		addq.b	#1,d2
		cmp.b	d2,d0
		bcc	fd_repeat2		;̃ZN^

		move.b	#1,d2
		bchg	#8,d2
		beq	fd_repeat4		;̍ŏ̃ZN^

		add.l	#1<<16,d2		;gbN\̑1ZN^
.ifdef X68030
		.fail	1
.else
		jsr	($ff8b12)		;FDSEEK
.endif
		btst	#ST0_NR+24,d0
		bne	fd_repeat0
fd_repeat2:
		adda	(2,a2),a2
		jmp	(a2)			;JԂ
fd_repeat0:
		adda	(a2),a2
		jmp	(a2)			;I
fd_repeat4:
		adda	(4,a2),a2
		jmp	(a2)			;JԂ()
		.endif

		.ifdef	HAVE_WAIT_05MS
		.fail	1
wait_05ms:
		rts
		.endif

		.ifdef	HAVE_WAIT_BUSY_OFF
		.fail	1
wait_busy_off:
		rts
		.endif


		.end

* ȉ IOCS R[yъ荞ݏ DMA gp
* Ȃ߁AtbNKv͂Ȃ.

* IOCS _B_SEEK($40)
* IOCS _B_DSKINI($43)
* IOCS _B_DRVSNS($44)
* IOCS _B_RECALI($47)
* IOCS _B_ASSIGN($48)	(FD ɑ΂Ă͎gps)
* IOCS _B_READID($4a)
* IOCS _B_BADFMT($4b)	(V)
* IOCS _B_DRVCHK($4e)
* IOCS _B_EJECT($4f)

* FDC Xe[^X荞($60)
* FDC }/ro荞($61)
* DMAC#0 I($64)
* DMAC#0 G[($65)

* End of File --------------------------------- *
