		.title	Yurika system - sram(SRAM 풓)


* Include File -------------------------------- *

		.include	yurika.mac

		.include	sram.mac
		.include	iomap.mac
		.include	vector.mac
		.include	console.mac
		.include	iocscall.mac
		.include	scsicall.mac


* Constant ------------------------------------ *

CRLF:		.reg	CR,LF

RTE_CODE:	.equ	$4e73


* I/O Address --------------------------------- *

VX_CTRL:	.equ	$ecf000
VX_ID1:		.equ	$ecf004
VX_ID2:		.equ	$ecf008
VX_REV:		.equ	$ecf00c


* IOCS Work ----------------------------------- *
* 󂢂Ă̈Ɏgp

BOOT_FLAG:	.equ	$fff


* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even


* wb_/[N ------------------------------- *

sram_start::
		bra.w	sram_start2		;$6000_xxxx
		.dc	sram_end-sram_start	;풓̃TCY
		.dc	prog_id-sram_start	;ʎqւ̃ItZbg

		.dc.l	-1			;dIt
		.dc.l	0			;IOCS _VDISPST ̃xN^
		.dc	$0000			;NfoCX
		.dc.b	$00			;VENUS-X }XNl
		.dc.b	$00			;	 Zbgl
		.even


* C ---------------------------------- *

sram_start2:

* ɋNłȂāAĂя̂h
* EXvAX荞݂tbNĂ邩ǂƁAROM 
*   Ăꍇɂ܂Ȃ.
* EIOCS _VDISPST tbNĂ邩ǂƁASRAM ɑ
*   vOāAXɃtbNꍇɂ܂Ȃ.
		tas	(BOOT_FLAG)
		bne	return			;ڈȍ~͖


		lea	(sram_start,pc),a6
* ^Cg\
		.ifdef	PRINT_TITLE
		lea	(title_mes,pc),a1
		IOCS	_B_PRINT
**		lea	(crlf,pc),a1
		IOCS	_B_PRINT
		.endif	/* PRINT_TITLE */


* XvAX荞݂}XN
		move	#RTE_CODE,d0
		lea	(IOCS_ROM),a0
@@:		cmp	(a0)+,d0		;ROM  rte T
		bne	@b
		subq.l	#2,a0
		move.l	a0,(SPURIOUS_VEC*4)


* TV ʃ~[g
		move.l	(SRAM_OFFTIMES),d0
		cmp.l	(~sram_offtime,a6),d0
		beq	skip_mute

		bsr	write_enable		;d on ̂ݎs
		move.l	d0,(~sram_offtime,a6)
		bsr	write_disable
		.if	0
		moveq	#6,d1			;~[g
		IOCS	_TVCTRL
		.else
@@:
		tst.b	(MFP_TSR)
		bpl	@b
		move.b	#6,(MFP_UDR)
		.endif
skip_mute:


* VENUS-X ݒ
		lea	(VX_CTRL),a0
		bsr	is_exist_venus_x
		tst.l	d0
		beq	skip_venus_x
		and.b	(~sram_vxmask,a6),d0
		or.b	(~sram_vxmode,a6),d0
		move.l	d0,(a0)			;䃌WX^ɏ
skip_venus_x:


* IOCS _VDISPST tbN
		bsr	write_enable
		move.l	($400+_VDISPST*4),(~sram_vdispst,a6)
		bsr	write_disable
		lea	(vdispst_patch,pc),a0
		move.l	a0,($400+_VDISPST*4)


* ROM IPL ́ANfoCX̐U蕪ɔэ.
**Lff0386:
**		move	(SRAM_BOOT),d1
**		beq	Lff03ac
**		btst	#2,(14,a1)
**		bne	Lff03ac
**		move	d1,d0
**		and	#$f000,d0		;<- ɔэ
**		rol	#4,d0
**		subq	#8,d0

		lea	(IOCS_ROM),a0
		move	#$3001,d0		;move d1,d0
@@:		cmp	(a0)+,d0
		bne	@b
		cmpi.l	#$c07c_f000,(a0)	;and #$f000,d0
		bne	@b
		cmpi.l	#$e958_5140,(4,a0)	;rol #4,d0 / subq #8,d0
		bne	@b
		
		move	(~sram_boot,a6),d1
		addq.l	#4,sp
		move	d1,d0
		jmp	(a0)			;N[`̓rɔэ
return:
		rts


* Tu[` -------------------------------- *

* SRAM ݋/֎~

write_enable:
		move.b	#$31,-(sp)
		bra	@f
write_disable:
		clr.b	-(sp)
@@:		move.b	(sp)+,(SYS_P7)
		rts


* VENUS-X ݌.
* in	a0.l	I/O AhX($ecf000)
* out	d0.l	0:VENUS-X ݂͑Ȃ
*		ȊO:݂

is_exist_venus_x:
		movem.l	d1/a0-a3,-(sp)
		moveq	#0,d0

		lea	(BUSERR_VEC*4),a1
		movea.l	(a1),a2
		lea	(sp),a3
		pea	(is_exist_vx_end,pc)
		move.l	(sp)+,(a1)		;oXG[OtbN

		move.l	(a0)+,d1		;VX_CTRL
		.irp	char,'V','X'
		move.l	(a0)+,d1		;VX_ID[1-2]
		cmpi.b	#char,d1
		bne	is_exist_vx_end
		.endm
		move.l	(a0)+,d1		;VX_REV
*is_exist_vx_true:
		moveq	#1,d0
is_exist_vx_end:
		lea	(a3),sp			;X^bNt[̂Ă
		move.l	a2,(a1)			;oXG[O߂
		movem.l	(sp)+,d1/a0-a3
		rts


* pb`R[h -------------------------------- *

vdispst_patch:
		move.l	a1,d0
		beq	vdispst_call_orig	;荞ݒ~

		move.l	(TIMERA_VEC*4),d0
		tst.b	(TIMERA_VEC*4)
		beq	vdispst_end		;Ɏgp

		lea	(MFP),a0
		move.b	(~MFP_TACR,a0),-(sp)
		clr.b	(~MFP_TACR,a0)		;^C}Xgbv
		move.l	a1,(TIMERA_VEC*4)
		move.b	d1,(~MFP_TADR,a0)	;荞ݎ
		move	d1,d0
		lsr	#4,d0
		andi.b	#$10,d0
		andi.b	#$ef,(~MFP_AER,a0)
		or.b	d0,(~MFP_AER,a0)	;荞݃^C~O
		moveq	#$20,d0
		or.b	d0,(~MFP_IERA,a0)
		or.b	d0,(~MFP_IMRA,a0)
		move.b	(sp)+,(~MFP_TACR,a0)	;JEgJn
		moveq	#0,d0
vdispst_end:
		rts
vdispst_call_orig:
		move.l	(sram_start+~sram_vdispst,pc),-(sp)
		rts


* Data Section -------------------------------- *

**		.data
		.even

		.ifdef	PRINT_TITLE
title_mes:	.dc.b	CRLF
		.endif	/* PRINT_TITLE */
prog_id:	.dc.b	SYSNAME,' version ',VERSION,0
		.ifdef	PRINT_TITLE
crlf:		.dc.b	CRLF,0
		.endif	/* PRINT_TITLE */


* tb^ -------------------------------------- *

		.quad
sram_end::

		.end

* End of File --------------------------------- *
